// Graph2D.cpp : Implementation of CGraph2D

#include "stdafx.h"
#include "Graph2DProj.h"
#include "Graph2D.h"

/////////////////////////////////////////////////////////////////////////////
// CGraph2D


STDMETHODIMP CGraph2D::AddGraph(COLORREF newColor, BSTR title, BOOL bRedraw, BOOL b_sort_x, BOOL b_keep_same_x, LONG *index)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	USES_CONVERSION;
    
    *index = CGraphWnd::AddGraph(newColor, OLE2T(title), bRedraw,b_sort_x, b_keep_same_x );

	return S_OK;
}

STDMETHODIMP CGraph2D::RemoveGraph(LONG index, BOOL bRedraw)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CGraphWnd::RemoveGraph( index, bRedraw );

	return S_OK;
}

STDMETHODIMP CGraph2D::get_GraphCount(long *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    *pVal = CGraphWnd::GetGraphCount();

	return S_OK;
}

STDMETHODIMP CGraph2D::AddPoint(LONG graphnum, DOUBLE x, DOUBLE y, BOOL bRedraw, LONG index)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CGraphWnd::AddPoint( graphnum, x, y, bRedraw, index );

	return S_OK;
}

STDMETHODIMP CGraph2D::EditPoint(LONG graphnum, LONG index, DOUBLE x, DOUBLE y, BOOL bRedraw, LONG * res)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CGraphWnd::EditPoint( graphnum, index, x, y, bRedraw );

	return S_OK;
}

STDMETHODIMP CGraph2D::RemovePoint(LONG graphnum, LONG index, BOOL bRedraw)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CGraphWnd::RemovePoint( graphnum, index, bRedraw );

	return S_OK;
}

STDMETHODIMP CGraph2D::ClearGraph(LONG graphnum, BOOL bRedraw)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CGraphWnd::ClearGraph( graphnum, bRedraw );

	return S_OK;
}

STDMETHODIMP CGraph2D::get_GraphAutoScale(BOOL *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	DWORD flags = CGraphWnd::GetGraphFlags();
    flags = flags & GRAPH_AUTOSCALE;
    *pVal = (flags > 0);

    return S_OK;
}

STDMETHODIMP CGraph2D::put_GraphAutoScale(BOOL newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	DWORD flags = CGraphWnd::GetGraphFlags();
    if (newVal)
    {
        flags = flags | GRAPH_AUTOSCALE;
    }
    else
    {
        flags = flags & (~GRAPH_AUTOSCALE);
    }
    CGraphWnd::SetGraphFlags(flags);

	return S_OK;
}

STDMETHODIMP CGraph2D::get_GraphSquarePoints(BOOL *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	DWORD flags = CGraphWnd::GetGraphFlags();
    flags = flags & GRAPH_SQUAREPOINTS;
    *pVal = (flags > 0);

	return S_OK;
}

STDMETHODIMP CGraph2D::put_GraphSquarePoints(BOOL newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	DWORD flags = CGraphWnd::GetGraphFlags();
    if (newVal)
    {
        flags = flags | GRAPH_SQUAREPOINTS;
    }
    else
    {
        flags = flags & (~GRAPH_SQUAREPOINTS);
    }
    CGraphWnd::SetGraphFlags(flags);

	return S_OK;
}

STDMETHODIMP CGraph2D::get_GraphShowTooltips(BOOL *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	DWORD flags = CGraphWnd::GetGraphFlags();
    flags = flags & GRAPH_SHOW_TOOLTIP;
    *pVal = (flags > 0);

	return S_OK;
}

STDMETHODIMP CGraph2D::put_GraphShowTooltips(BOOL newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	DWORD flags = CGraphWnd::GetGraphFlags();
    if (newVal)
    {
        flags = flags | GRAPH_SHOW_TOOLTIP;
    }
    else
    {
        flags = flags & (~GRAPH_SHOW_TOOLTIP);
    }
    CGraphWnd::SetGraphFlags(flags);

	return S_OK;
}

STDMETHODIMP CGraph2D::get_GraphDrawAxis( BOOL *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	DWORD flags = CGraphWnd::GetGraphFlags();
    flags = flags & GRAPH_DRAW_AXIS;
    *pVal = (flags > 0)?TRUE:FALSE;

	return S_OK;
}

STDMETHODIMP CGraph2D::put_GraphDrawAxis( BOOL newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	DWORD flags = CGraphWnd::GetGraphFlags();
    if (newVal == VARIANT_TRUE)
    {
        flags = flags | GRAPH_DRAW_AXIS;
    }
    else
    {
        flags = flags & (~GRAPH_DRAW_AXIS);
    }
    CGraphWnd::SetGraphFlags(flags);

	return S_OK;
}

STDMETHODIMP CGraph2D::get_GraphScatter(BOOL *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	DWORD flags = CGraphWnd::GetGraphFlags();
    flags = flags & GRAPH_GRAPH_SCATTER;
    *pVal = (flags > 0);

	return S_OK;
}

STDMETHODIMP CGraph2D::put_GraphScatter(BOOL newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	DWORD flags = CGraphWnd::GetGraphFlags();
    if (newVal)
    {
        flags = flags | GRAPH_GRAPH_SCATTER;
    }
    else
    {
        flags = flags & (~GRAPH_GRAPH_SCATTER);
    }
    CGraphWnd::SetGraphFlags(flags);

	return S_OK;
}


STDMETHODIMP CGraph2D::get_XAxisTitle(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    USES_CONVERSION; 

    CAxisProps * props = CGraphWnd::GetAxisProps( GRAPH_X_AXIS );
    *pVal = T2BSTR(props->GetTitle());

	return S_OK;
}

STDMETHODIMP CGraph2D::put_XAxisTitle(BSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    USES_CONVERSION;

    CAxisProps * props = CGraphWnd::GetAxisProps( GRAPH_X_AXIS );
    CGraphWnd::SetAxisProps(OLE2T(newVal),props->GetUOM(),props->GetPrecision(),GRAPH_X_AXIS);

	return S_OK;
}

STDMETHODIMP CGraph2D::get_YAxisTitle(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    USES_CONVERSION; 
    
    CAxisProps * props = CGraphWnd::GetAxisProps( GRAPH_Y_AXIS );
    *pVal = T2BSTR(props->GetTitle());

	return S_OK;
}

STDMETHODIMP CGraph2D::put_YAxisTitle(BSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    USES_CONVERSION;

    CAxisProps * props = CGraphWnd::GetAxisProps( GRAPH_X_AXIS );
    CGraphWnd::SetAxisProps(OLE2T(newVal),props->GetUOM(),props->GetPrecision(),GRAPH_Y_AXIS);

	return S_OK;
}

STDMETHODIMP CGraph2D::get_XAxisUOM(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    USES_CONVERSION; 
    
    CAxisProps * props = CGraphWnd::GetAxisProps( GRAPH_X_AXIS );
    *pVal = T2BSTR(props->GetUOM());

	return S_OK;
}

STDMETHODIMP CGraph2D::put_XAxisUOM(BSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    USES_CONVERSION;

    CAxisProps * props = CGraphWnd::GetAxisProps( GRAPH_X_AXIS );
    CGraphWnd::SetAxisProps(props->GetTitle(),OLE2T(newVal),props->GetPrecision(),GRAPH_X_AXIS);

	return S_OK;
}

STDMETHODIMP CGraph2D::get_YAxisUOM(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    USES_CONVERSION; 
    
    CAxisProps * props = CGraphWnd::GetAxisProps( GRAPH_Y_AXIS );
    *pVal = T2BSTR(props->GetUOM());

	return S_OK;
}

STDMETHODIMP CGraph2D::put_YAxisUOM(BSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    USES_CONVERSION;

    CAxisProps * props = CGraphWnd::GetAxisProps( GRAPH_X_AXIS );
    CGraphWnd::SetAxisProps(props->GetTitle(),OLE2T(newVal),props->GetPrecision(),GRAPH_Y_AXIS);

	return S_OK;
}

STDMETHODIMP CGraph2D::get_XAxisPrecision(LONG *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CAxisProps * props = CGraphWnd::GetAxisProps( GRAPH_X_AXIS );
    *pVal = props->GetPrecision();

	return S_OK;
}

STDMETHODIMP CGraph2D::put_XAxisPrecision(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CAxisProps * props = CGraphWnd::GetAxisProps( GRAPH_X_AXIS );
    CGraphWnd::SetAxisProps(props->GetTitle(),props->GetUOM(),newVal,GRAPH_X_AXIS);

	return S_OK;
}

STDMETHODIMP CGraph2D::get_YAxisPrecision(LONG *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CAxisProps * props = CGraphWnd::GetAxisProps( GRAPH_Y_AXIS );
    *pVal = props->GetPrecision();

	return S_OK;
}

STDMETHODIMP CGraph2D::put_YAxisPrecision(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CAxisProps * props = CGraphWnd::GetAxisProps( GRAPH_X_AXIS );
    CGraphWnd::SetAxisProps(props->GetTitle(),props->GetUOM(),newVal,GRAPH_Y_AXIS);

	return S_OK;
}

STDMETHODIMP CGraph2D::get_BoundRectMinX(DOUBLE *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    double maxx,miny,maxy;
    // Should handle the return with an error
    CGraphWnd::GetBoundRect( pVal, &maxx, &miny, &maxy );

	return S_OK;
}

STDMETHODIMP CGraph2D::get_BoundRectMaxX(DOUBLE *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    double minx,miny,maxy;
    // Should handle the return with an error
    CGraphWnd::GetBoundRect( &minx, pVal, &miny, &maxy );

	return S_OK;
}


STDMETHODIMP CGraph2D::get_BoundRectMinY(DOUBLE *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    double minx,maxx,maxy;
    // Should handle the return with an error
    CGraphWnd::GetBoundRect( &minx, &maxx, pVal, &maxy );

	return S_OK;
}


STDMETHODIMP CGraph2D::get_BoundRectMaxY(DOUBLE *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    double minx,maxx,miny;
    // Should handle the return with an error
    CGraphWnd::GetBoundRect( &minx, &maxx, &miny, pVal );

	return S_OK;
}

STDMETHODIMP CGraph2D::get_WorldCoordsX1(DOUBLE *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    double x2,y1,y2;
    CGraphWnd::GetGraphWorldCoords( pVal, &x2, &y1, &y2 );

	return S_OK;
}

STDMETHODIMP CGraph2D::put_WorldCoordsX1(DOUBLE newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    double x1,x2,y1,y2;
    CGraphWnd::GetGraphWorldCoords( &x1, &x2, &y1, &y2 );
    CGraphWnd::SetGraphWorldCoords( newVal, x2, y1, y2 );

	return S_OK;
}

STDMETHODIMP CGraph2D::get_WorldCoordsX2(DOUBLE *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    double x1,y1,y2;
    CGraphWnd::GetGraphWorldCoords( &x1, pVal, &y1, &y2 );

	return S_OK;
}

STDMETHODIMP CGraph2D::put_WorldCoordsX2(DOUBLE newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    double x1,x2,y1,y2;
    CGraphWnd::GetGraphWorldCoords( &x1, &x2, &y1, &y2 );
    CGraphWnd::SetGraphWorldCoords( x1, newVal, y1, y2 );

	return S_OK;
}

STDMETHODIMP CGraph2D::get_WorldCoordsY1(DOUBLE *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    double x1,x2,y2;
    CGraphWnd::GetGraphWorldCoords( &x1, &x2, pVal, &y2 );

	return S_OK;
}

STDMETHODIMP CGraph2D::put_WorldCoordsY1(DOUBLE newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    double x1,x2,y1,y2;
    CGraphWnd::GetGraphWorldCoords( &x1, &x2, &y1, &y2 );
    CGraphWnd::SetGraphWorldCoords( x1, x2, newVal, y2 );

	return S_OK;
}

STDMETHODIMP CGraph2D::get_WorldCoordsY2(DOUBLE *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    double x1,x2,y1;
    CGraphWnd::GetGraphWorldCoords( &x1, &x2, &y1, pVal );

	return S_OK;
}

STDMETHODIMP CGraph2D::put_WorldCoordsY2(DOUBLE newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    double x1,x2,y1,y2;
    CGraphWnd::GetGraphWorldCoords( &x1, &x2, &y1, &y2 );
    CGraphWnd::SetGraphWorldCoords( x1, x2, y1, newVal );

	return S_OK;
}

STDMETHODIMP CGraph2D::FormatAxisOutput(DOUBLE value, BOOL bXAxis, LONG format_level, BSTR *res_str)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CString tmpstr;
    CGraphWnd::FormatAxisOutput( value, bXAxis, format_level, tmpstr );
    *res_str = tmpstr.AllocSysString();

	return S_OK;
}

STDMETHODIMP CGraph2D::UpdateWindows(ULONG what_to_update)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CGraphWnd::UpdateWindowsA( what_to_update );

	return S_OK;
}

STDMETHODIMP CGraph2D::OperateWithPointView(ULONG pview_operations)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CGraphWnd::OperateWithPointViewA( pview_operations );

	return S_OK;
}

STDMETHODIMP CGraph2D::DrawGraphToDC(LONG *hDC, DOUBLE x1, DOUBLE x2, DOUBLE y1, DOUBLE y2)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CDC tmpCDC;
    tmpCDC.Attach((HDC) hDC);
    CRect r( x1, y1, x2, y2 );
    CGraphWnd::DrawGraphToDC( &tmpCDC , r);

	return S_OK;
}

STDMETHODIMP CGraph2D::get_GraphIsVisible(LONG graphindex, BOOL *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    if ( ( graphindex < 0 ) || (graphindex >= CGraphWnd::GetGraphCount()) ) 
    {
        return E_INVALIDARG;
    }

    *pVal = CGraphWnd::GetGraph( graphindex )->IsVisible();

	return S_OK;
}

STDMETHODIMP CGraph2D::put_GraphIsVisible(LONG graphindex, BOOL newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    if ( ( graphindex < 0 ) || (graphindex >= CGraphWnd::GetGraphCount()) ) 
    {
        return E_INVALIDARG;
    }

	CGraphWnd::GetGraph( graphindex )->SetVisible( newVal );

	return S_OK;
}

STDMETHODIMP CGraph2D::get_GraphColor(LONG graphindex, COLORREF *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    if ( ( graphindex < 0 ) || (graphindex >= CGraphWnd::GetGraphCount()) ) 
    {
        return E_INVALIDARG;
    }

	*pVal = CGraphWnd::GetGraph( graphindex )->GetGraphColor( );

	return S_OK;
}

STDMETHODIMP CGraph2D::put_GraphColor(LONG graphindex, COLORREF newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	if ( ( graphindex < 0 ) || (graphindex >= CGraphWnd::GetGraphCount()) ) 
    {
        return E_INVALIDARG;
    }

	CGraphWnd::GetGraph( graphindex )->SetGraphColor( newVal );

	return S_OK;
}

STDMETHODIMP CGraph2D::get_GraphTitle(LONG graphindex, BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    USES_CONVERSION;

    if ( ( graphindex < 0 ) || (graphindex >= CGraphWnd::GetGraphCount()) ) 
    {
        return E_INVALIDARG;
    }

	*pVal = T2BSTR( CGraphWnd::GetGraph( graphindex )->GetTitle( ) );

	return S_OK;
}

STDMETHODIMP CGraph2D::put_GraphTitle(LONG graphindex, BSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    USES_CONVERSION;

	if ( ( graphindex < 0 ) || (graphindex >= CGraphWnd::GetGraphCount()) ) 
    {
        return E_INVALIDARG;
    }

	CGraphWnd::GetGraph( graphindex )->SetTitle( OLE2T( newVal ) );

	return S_OK;
}
